import { BaseSqlExpression } from './base-sql-expression.js';
/**
 * Do not use me directly. Use {@link col}
 */
export declare class Col extends BaseSqlExpression {
    private readonly brand;
    readonly identifiers: string[];
    constructor(...identifiers: string[]);
}
/**
 * Creates an object which represents a column in the DB, this allows referencing another column in your query.
 * This is often useful in conjunction with {@link fn}, {@link where} and {@link sql} which interpret strings as values and not column names.
 *
 * Col works similarly to {@link Identifier}, but "*" has special meaning, for backwards compatibility.
 *
 * ⚠️ We recommend using {@link Identifier}, or {@link Attribute} instead.
 *
 * @param identifiers The name of the column
 */
export declare function col(...identifiers: string[]): Col;
