import { Literal } from './literal.js';
/**
 * The template tag function used to easily create {@link literal}.
 *
 * @param rawSql
 * @param values
 * @example
 * ```ts
 * sql`SELECT * FROM ${sql.identifier(table)} WHERE ${sql.identifier(column)} = ${value}`
 * ```
 */
export declare function sql(rawSql: TemplateStringsArray, ...values: unknown[]): Literal;
export declare namespace sql {
    var attribute: typeof import("./attribute.js").attribute;
    var cast: typeof import("./cast.js").cast;
    var col: typeof import("./col.js").col;
    var fn: typeof import("./fn.js").fn;
    var identifier: typeof import("./identifier.js").identifier;
    var jsonPath: typeof import("./json-path.js").jsonPath;
    var list: typeof import("./list.js").list;
    var literal: typeof import("./literal.js").literal;
    var where: typeof import("./where.js").where;
    var unquote: (...args: unknown[]) => import("./dialect-aware-fn.js").DialectAwareFn;
}
